-- Turbine Imports..

import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";

--import d'un des scripts

import "Galphoglas.LotroChannFilter.ColorPicker.ColorPicker";
import "Galphoglas.LotroChannFilter.ClefMagique";
import "Galphoglas.LotroChannFilter.Language";

Turbine.Shell.WriteLine(lang["Chargement"][L]);

----------------------------
-- Variables Principales
----------------------------
version="1.2.3"

listecanal={"UserChat1","UserChat2","UserChat3","UserChat4","UserChat5","UserChat6","UserChat7","UserChat8","Fellowship","Kinship","Tell","Trade","Emote","EnemyCombat","Error","OOC","Roleplay","PlayerCombat","World","Death","Officer","Say","Advancement","Quest","Raid","LFF","Regional","Tribe"};
tradcanal=lang["Trad"][L];
----------------------------
-- Premiere utilisation
----------------------------

gauche = 200;
haut = 200;
couleur = {};
for i=1,28
do
	couleur[i]=Turbine.UI.Color(1,1,1);
end
listeBan={"Pay.com"}

filtreSpam=false;
DelaisSpam=5;
AntiSpamActive=false;
Memoire={};
Memoire[1]={};
Memoire[1].Message="Premier Message";
Memoire[1].Temps=0;
Memoire[2]={};
Memoire[2].Message="Deuxieme Message";
Memoire[2].Temps=0;
k=1;

Pause=false;

----------------------------------
-- Fenetre des parametres
----------------------------------

lcf = Turbine.UI.Lotro.Window();

lcf:SetSize(500,500);
lcf:SetPosition(gauche,haut);
lcf:SetText(lang["Titre1"][L]);
lcf:SetVisible(false);

-- Chexkbox

lcf.Check = Turbine.UI.Lotro.CheckBox();
lcf.Color = Turbine.UI.Window();
for i=1,28
do
py=60+22*i;
	if py<390 then
		lcf.Check[listecanal[i]] = Turbine.UI.Lotro.CheckBox();
		lcf.Check[listecanal[i]]:SetParent(lcf);
		lcf.Check[listecanal[i]]:SetText(tradcanal[i]);
		lcf.Check[listecanal[i]]:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
		lcf.Check[listecanal[i]]:SetForeColor(Turbine.UI.Color(0.8, 0.75, 0.5));
		lcf.Check[listecanal[i]]:SetSize(150, 20);
		lcf.Check[listecanal[i]]:SetPosition(60, py);
		lcf.Check[listecanal[i]]:SetCheckAlignment(Turbine.UI.ContentAlignment.MiddleRight);
		lcf.Check[listecanal[i]].MouseEnter = function()
			if lcf.Check[listecanal[i]]:IsChecked() then
				info("ok");
			else
				info("nok");
			end
		end
		lcf.Check[listecanal[i]].MouseLeave = function()
			info(0);
		end
		
		lcf.Color[listecanal[i]] =Turbine.UI.Window();
		lcf.Color[listecanal[i]]:SetSize(18,18);
		lcf.Color[listecanal[i]]:SetPosition(221, py+1);
		lcf.Color[listecanal[i]]:SetBackColor(couleur[i]);
		lcf.Color[listecanal[i]]:SetParent(lcf);
		lcf.Color[listecanal[i]]:SetVisible(true);
		lcf.Color[listecanal[i]].MouseClick = function()
			cp:SetVisible(true);
			lcf.app:SetVisible(false);
			cp.LeftClick= function ()
				lcf.Color[listecanal[i]]:SetBackColor(cp.GetTurbineColor());
				cp:SetVisible(false);
				lcf.app:SetVisible(true);
				info(0);
			end
		end
		lcf.Color[listecanal[i]].MouseEnter = function()
			info("color");
		end
		lcf.Color[listecanal[i]].MouseLeave = function()
			info(0);
		end
		
	else
	
	
		lcf.Check[listecanal[i]] = Turbine.UI.Lotro.CheckBox();
		lcf.Check[listecanal[i]]:SetParent(lcf);
		lcf.Check[listecanal[i]]:SetText(tradcanal[i]);
		lcf.Check[listecanal[i]]:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
		lcf.Check[listecanal[i]]:SetForeColor(Turbine.UI.Color(0.8, 0.75, 0.5));
		lcf.Check[listecanal[i]]:SetSize(150, 20);
		lcf.Check[listecanal[i]]:SetPosition(260, py-308);
		lcf.Check[listecanal[i]]:SetCheckAlignment(Turbine.UI.ContentAlignment.MiddleRight);
		lcf.Check[listecanal[i]].MouseEnter = function()
			if lcf.Check[listecanal[i]]:IsChecked() then
				info("ok");
			else
				info("nok");
			end
		end
		lcf.Check[listecanal[i]].MouseLeave = function()
			info(0);
		end
		
		lcf.Color[listecanal[i]] =Turbine.UI.Window();
		lcf.Color[listecanal[i]]:SetSize(18,18);
		lcf.Color[listecanal[i]]:SetPosition(421, py-307);
		lcf.Color[listecanal[i]]:SetBackColor(couleur[i]);
		lcf.Color[listecanal[i]]:SetParent(lcf);
		lcf.Color[listecanal[i]]:SetVisible(true);
		lcf.Color[listecanal[i]].MouseClick = function()
			cp:SetVisible(true);
			lcf.app:SetVisible(false);
			cp.LeftClick= function ()
				lcf.Color[listecanal[i]]:SetBackColor(cp.GetTurbineColor());				
				cp:SetVisible(false);
				lcf.app:SetVisible(true);
				info(0);
			end
		end
		lcf.Color[listecanal[i]].MouseEnter = function()
			info("color");
		end
		lcf.Color[listecanal[i]].MouseLeave = function()
			info(0);
		end
	end
	--Pour ceux qui nécéssite la poubelle
	if i<=8 or i==12 or i==16 or i==17 or i==19 or i==26 or i==27 then
		lcf.Check[listecanal[i]]:SetForeColor(Turbine.UI.Color(1, 1, 1));
	end
end

-- Selecteur de couleur

cp = ColorPicker.ColorPicker.Create();
cp:SetParent(lcf);
cp:SetSize(450,70);
cp:SetPosition(25,400);
cp:SetVisible(false);
cp.RightClick=function()
	cp:SetVisible(false);
	lcf.app:SetVisible(true);
	info(0);
end
cp.MouseEnter = function()
	info("cpinfo");
end

-- Horodateur
-- Se lance dans le charge settings

function SelecteurHoro()
	listehoro=lang["Horodateur"][L];
	lcf.horo = DropDown.Create(listehoro,valhoro);
	lcf.horo:SetParent(lcf);
	lcf.horo:ApplyWidth(175); 
	lcf.horo:SetMaxItems(6); 
	lcf.horo:SetPosition(60,40);
	lcf.horo:SetVisible(true);
end
	
-- Button

lcf.mot = Turbine.UI.Lotro.Button();
lcf.mot:SetParent(lcf);
lcf.mot:SetPosition(250, 40);
lcf.mot:SetSize(200, 20);
lcf.mot:SetText(lang["Titre2"][L]);
lcf.mot:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
lcf.mot.Click = function()
	lcf:SetVisible(false);
	listeMotsBan();
end
lcf.mot.MouseEnter = function()
		info("motban");
	end
lcf.mot.MouseLeave =function()
		info(0);
end

lcf.app = Turbine.UI.Lotro.Button();
lcf.app:SetParent(lcf);
lcf.app:SetPosition(150, 425);
lcf.app:SetSize(200, 20);
lcf.app:SetText(lang["AppliquerDef"][L]);
lcf.app:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
lcf.app.Click = function()
	saveSettings();
	lcf:SetVisible(false);
	lcfliste:SetVisible(false);
end
lcf.app.MouseEnter = function()
		info("appliquer");
	end
lcf.app.MouseLeave =function()
		info(0);
end

-- Sauvegarde des parametres

function saveSettings()
	
	settings={};--para géné
	settings.Gauche=lcf:GetLeft();
	settings.Haut=lcf:GetTop();
	settings.Horo=lcf.horo:GetText();
	
	settingsColor={};--para couleur
	settingsMot={};--para couleur
	
	for i=1,28
	do
		settings[listecanal[i]]=lcf.Check[listecanal[i]]:IsChecked();--regarde check
	
		settingsColor[listecanal[i]]=lcf.Color[listecanal[i]]:GetBackColor();--regarde color
	
		color[listecanal[i]]=lcf.Color[listecanal[i]]:GetBackColor();
		settingsColor[listecanal[i]].R=(color[listecanal[i]].R)*10000;--pour corriger le probleme de compréhension de la virgule dans les plugindata
		settingsColor[listecanal[i]].G=(color[listecanal[i]].G)*10000;
		settingsColor[listecanal[i]].B=(color[listecanal[i]].B)*10000;
	
	end
	
	Turbine.PluginData.Save(Turbine.DataScope.Character, "lcf", settings);--save check
	Turbine.PluginData.Save(Turbine.DataScope.Character, "lcfColor", settingsColor);--save color
	
end

-- Récupération

function chargeSetting()

	--chargement check+position
	settings=Turbine.PluginData.Load(Turbine.DataScope.Character, "lcf");
	if settings==nil then
		settings={}
	else
		gauche=settings.Gauche;
		haut=settings.Haut;
		lcf:SetPosition(gauche,haut);
		valhoro=settings.Horo;
		if valhoro ~=lang["HoroDefaut"][L] then
			valhoro=lang["HoroDefaut"][L]
		end
		for i=1,28
		do
			lcf.Check[listecanal[i]]:SetChecked(settings[listecanal[i]]);
		end
	end
	
	--chargement color
	settingsColor=Turbine.PluginData.Load(Turbine.DataScope.Character, "lcfColor");
	if settingsColor==nil then
		settingsColor={}
	else
		for i=1,28
		do
			lcf.Color[listecanal[i]]:SetBackColor(Turbine.UI.Color(settingsColor[listecanal[i]].R/10000,settingsColor[listecanal[i]].G/10000,settingsColor[listecanal[i]].B/10000));--pour corriger le probleme de compréhension de la virgule dans les plugindata
		end
	end

	--chargement mot
	chargeMots();
	
	-- Horodateur ajouter ici car impossible de le faire mettre a jour autrement
	SelecteurHoro(valhoro);
	
end

------------------
-- Commandes
------------------

LCFCommand = Turbine.ShellCommand();

function LCFCommand:Execute(cmd, args)
	if (args == lang["Visible"][L]) then
		lcf:SetVisible(true);
	elseif (args == lang["RAZ"][L]) then
		RaZ();
	elseif (args == lang["Pause"][L]) then
		if (Pause==true) then
			Turbine.Shell.WriteLine(lang["Pause1"][L]);
			Turbine.Shell.WriteLine(lang["Pause2"][L]);
		else
			Pause=true;
			Turbine.Shell.WriteLine(lang["Pause3"][L]);
			Turbine.Shell.WriteLine(lang["Pause4"][L]);
		end
	elseif (args == lang["Reprise"][L]) then
		if (Pause==false) then
			Turbine.Shell.WriteLine(lang["Reprise1"][L]);
			Turbine.Shell.WriteLine(lang["Reprise2"][L]);
		else
			Pause=false;
			Turbine.Shell.WriteLine(lang["Reprise3"][L]);
		end
	else
		LCFCommand:GetHelp();
	end
end

function LCFCommand:GetHelp()
	Turbine.Shell.WriteLine(lang["Info1"][L].. version);
	Turbine.Shell.WriteLine(lang["Info2"][L]);
	Turbine.Shell.WriteLine(lang["Info3"][L]);
	Turbine.Shell.WriteLine("");
	Turbine.Shell.WriteLine(lang["Info4"][L]);
	Turbine.Shell.WriteLine(lang["Info5"][L]);
	Turbine.Shell.WriteLine("");
	Turbine.Shell.WriteLine(lang["Info6"][L]);
	Turbine.Shell.WriteLine(lang["Info7"][L]);
	Turbine.Shell.WriteLine(lang["Info8"][L]);
	Turbine.Shell.WriteLine("");
	Turbine.Shell.WriteLine(lang["Info9"][L]);
end


---------------------------
-- Fonction de travail
---------------------------

function AddCallback(object, event, callback, color)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end

function chatHandler(sender, args)

	color={};
	flag=0;
	flagSpam=false;

	if (Pause==false) then		
		for i=1,28
		do
			 if (args.ChatType == Turbine.ChatType[listecanal[i]] and lcf.Check[listecanal[i]]:IsChecked()) then --On regarde si le filtre correspondant est activer a chaque nouveau message sur un canal
				Message = string.lower(args.Message) -- on enleve toutes les majuscules pour etre sur de la comparaison
				j=1;				
				while j<=table.getn(listeBan)
				do				
					if string.match(Correction(Message), Correction(string.lower(listeBan[j]))) then --On regarde si le mot est dans la liste
						flag=1;
					end
					j=j+1;
				end
				if (flag==0) then --Si le mot n'est pas dans la liste on lvérifie si c'est un spam
					if (AntiSpamActive==true) then					
						for l=1, table.getn(Memoire)
							do					
							if (Memoire[l].Message==Message) then
								if (Memoire[l].Temps+DelaisSpam>=Turbine.Engine.GetGameTime()) then
									flagSpam=true;
								else
									Memoire[l].Temps=Turbine.Engine.GetGameTime();
									color[listecanal[i]]=lcf.Color[listecanal[i]]:GetBackColor();-- On récupère la couleur
									Turbine.Shell.WriteLine("<rgb=#"..tostring(DEC_HEX(math.floor(255*color[listecanal[i]].R))..DEC_HEX(math.floor(255*color[listecanal[i]].G))..DEC_HEX(math.floor(255*color[listecanal[i]].B)))..">"..Horodateur()..args.Message);-- on écrit le tout :p
									flagSpam=true;
								end
							end
						end					
						if (flagSpam==true) then 
							flagSpam=false;
						else
							Memoire[k]={};
							Memoire[k].Message=Message;
							Memoire[k].Temps=Turbine.Engine.GetGameTime();
							k=k+1;
							color[listecanal[i]]=lcf.Color[listecanal[i]]:GetBackColor();-- On récupère la couleur
							Turbine.Shell.WriteLine("<rgb=#"..tostring(DEC_HEX(math.floor(255*color[listecanal[i]].R))..DEC_HEX(math.floor(255*color[listecanal[i]].G))..DEC_HEX(math.floor(255*color[listecanal[i]].B)))..">"..Horodateur()..args.Message);-- on écrit le tout :p
						end
					else
						color[listecanal[i]]=lcf.Color[listecanal[i]]:GetBackColor();-- On récupère la couleur
						Turbine.Shell.WriteLine("<rgb=#"..tostring(DEC_HEX(math.floor(255*color[listecanal[i]].R))..DEC_HEX(math.floor(255*color[listecanal[i]].G))..DEC_HEX(math.floor(255*color[listecanal[i]].B)))..">"..Horodateur()..args.Message);-- on écrit le tout :p
					end
				end
				flag=0;
			end
		end
	end
	
end

function DEC_HEX(IN) --Fonction crée par Gahulad présente dans le colorpicker (déjà) repris ici
		local B,K,OUT,I,D=16,"0123456789ABCDEF","",0
			if IN == 0 then return "00" end;
			while IN>0 do
			I=I+1
			IN,D=math.floor(IN/B),math.mod(IN,B)+1
			OUT=string.sub(K,D,D)..OUT
		end
		if string.len(OUT) == 1 then OUT = "0" .. OUT end;
		return OUT
	end

-----------------
-- Horodateur
-----------------

function Horodateur()
	an=Turbine.Engine.GetDate().Year;
	mo=Turbine.Engine.GetDate().Month;
	jo=Turbine.Engine.GetDate().Day;

	he=Turbine.Engine.GetDate().Hour;
	mi=Turbine.Engine.GetDate().Minute;
	se=Turbine.Engine.GetDate().Second;
	
	if an<10 then an="0"..an end
	if mo<10 then mo="0"..mo end
	if jo<10 then jo="0"..jo end
	
	if he<10 then he="0"..he end
	if mi<10 then mi="0"..mi end
	if se<10 then se="0"..se end
	
	if (lcf.horo:GetText()==lang["Horo1"][L]) then horo= "["..an.."/"..mo.."/"..jo..", "..he..":"..mi..":"..se.."] "
	elseif (lcf.horo:GetText()==lang["Horo2"][L]) then horo= "["..an.."/"..mo.."/"..jo..", "..he..":"..mi.."] "
	elseif (lcf.horo:GetText()==lang["Horo3"][L]) then horo= "["..jo.."/"..mo.."/"..an..", "..he..":"..mi..":"..se.."] "
	elseif (lcf.horo:GetText()==lang["Horo4"][L]) then horo= "["..jo.."/"..mo.."/"..an..", "..he..":"..mi.."] "
	elseif (lcf.horo:GetText()==lang["Horo5"][L]) then horo= "["..mo.."/"..jo..", "..he..":"..mi..":"..se.."] "
	elseif (lcf.horo:GetText()==lang["Horo6"][L]) then horo= "["..mo.."/"..jo..", "..he..":"..mi.."] "
	elseif (lcf.horo:GetText()==lang["Horo7"][L]) then horo= "["..jo.."/"..mo..", "..he..":"..mi..":"..se.."] "
	elseif (lcf.horo:GetText()==lang["Horo8"][L]) then horo= "["..jo.."/"..mo..", "..he..":"..mi.."] "
	elseif (lcf.horo:GetText()==lang["Horo9"][L]) then horo= "["..he..":"..mi..":"..se.."] "
	elseif (lcf.horo:GetText()==lang["Horo10"][L]) then horo= "["..he..":"..mi.."] "
	else horo="" end
	
	return horo;
		
end

---------------
-- AntiSpam
---------------

function Delais()
	if valIntervalleSpam==lang["Spam1"][L] then DelaisSpam=5;
	elseif valIntervalleSpam==lang["Spam2"][L] then DelaisSpam=10;
	elseif valIntervalleSpam==lang["Spam3"][L] then DelaisSpam=15;
	elseif valIntervalleSpam==lang["Spam4"][L] then DelaisSpam=20;
	elseif valIntervalleSpam==lang["Spam5"][L] then DelaisSpam=25;
	elseif valIntervalleSpam==lang["Spam6"][L] then DelaisSpam=30;
	elseif valIntervalleSpam==lang["Spam7"][L] then DelaisSpam=35;
	elseif valIntervalleSpam==lang["Spam8"][L] then DelaisSpam=40;
	elseif valIntervalleSpam==lang["Spam9"][L] then DelaisSpam=45;
	elseif valIntervalleSpam==lang["Spam10"][L] then DelaisSpam=50;
	elseif valIntervalleSpam==lang["Spam11"][L] then DelaisSpam=55;
	elseif valIntervalleSpam==lang["Spam12"][L] then DelaisSpam=60;
	elseif valIntervalleSpam==lang["Spam13"][L] then DelaisSpam=90;
	elseif valIntervalleSpam==lang["Spam14"][L] then DelaisSpam=120;
	elseif valIntervalleSpam==lang["Spam15"][L] then DelaisSpam=150;
	elseif valIntervalleSpam==lang["Spam16"][L] then DelaisSpam=180;
	elseif valIntervalleSpam==lang["Spam17"][L] then DelaisSpam=210;
	elseif valIntervalleSpam==lang["Spam18"][L] then DelaisSpam=240;
	elseif valIntervalleSpam==lang["Spam19"][L] then DelaisSpam=270;
	elseif valIntervalleSpam==lang["Spam20"][L] then DelaisSpam=300;
	end
	
	return DelaisSpam;
end


-------------------
-- Construction
-------------------

-- Importations des scripts

import "Galphoglas.LotroChannFilter.DropDown";
import "Galphoglas.LotroChannFilter.mots";
import "Galphoglas.LotroChannFilter.confirmation";
import "Galphoglas.LotroChannFilter.information";

-- Chargement des parametres

chargeSetting();

-- Mise en place des commandes

AddCallback(Turbine.Chat, "Received", chatHandler, color);
Turbine.Shell.AddCommand("lcf", LCFCommand);

-- Confirmation de réussite de l'opération

Turbine.Shell.WriteLine(lang["Lance"][L]);
Turbine.Shell.WriteLine(lang["PlusInfo"][L]);