import "Galphoglas.LotroChannFilter.DropDown";

lcfliste = Turbine.UI.Lotro.Window();--Déclaration plus haut pour récupérer partout
lcfliste.SaisieListe = Turbine.UI.ListBox();--Déclaration plus haut pour récupérer partout
lcfliste.supp= Turbine.UI.Lotro.Button();--Déclaration plus haut pour récupérer partout
lcfliste.AntiSpam = Turbine.UI.Lotro.CheckBox();--Déclaration plus haut pour récupérer partout

valIntervalleSpam = lang["IntSpam"][L];

-- ScrollBar de l'Affichage

lcfliste.ScrollBar = Turbine.UI.Lotro.ScrollBar();
lcfliste.ScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
lcfliste.ScrollBar:SetParent(lcfliste);
lcfliste.ScrollBar:SetPosition(440,130);
lcfliste.ScrollBar:SetSize(10,270);
	
function listeMotsBan()
	
	lcfliste:SetSize(500,500);
	lcfliste:SetPosition(lcf:GetLeft(),lcf:GetTop());
	lcfliste:SetText(lang["ListeMotBan"][L]);
	lcfliste:SetVisible(true);
	lcfliste.Closing= function()
		lcf:SetPosition(lcfliste:GetLeft(),lcfliste:GetTop());
		lcf:SetVisible(true);
	end
	
	lcfliste.app = Turbine.UI.Lotro.Button();
	lcfliste.app:SetParent(lcfliste);
	lcfliste.app:SetPosition(150, 425);
	lcfliste.app:SetSize(200, 20);
	lcfliste.app:SetText(lang["Appliquer"][L]);
	lcfliste.app:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	lcfliste.app.Click = function()
		if lcfliste.AntiSpam:IsChecked() then
			AntiSpamActive=true;
		else
			AntiSpamActive=false;
		end
		valIntervalleSpam=lcfliste.IntervalleSpam:GetText();
		saveMots();
		lcfliste:SetVisible(false);
		lcf:SetPosition(lcfliste:GetLeft(),lcfliste:GetTop());
		lcf:SetVisible(true);
	end
	lcfliste.app.MouseEnter = function()
		info("appliquer 2");
	end
	lcfliste.app.MouseLeave =function()
		info(0);
	end
	
	
	--ajout
	lcfliste.SaisieLabel = Turbine.UI.Label();
	lcfliste.SaisieLabel:SetParent(lcfliste);
	lcfliste.SaisieLabel:SetText(lang["AjoutEl"][L]);
	lcfliste.SaisieLabel:SetPosition(50,50);
	lcfliste.SaisieLabel:SetSize(300,15);
	lcfliste.SaisieLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	lcfliste.SaisieLabel:SetForeColor(Turbine.UI.Color(0.8, 0.75, 0.5));
	
	lcfliste.SaisieTextbox = Turbine.UI.Lotro.TextBox();
	lcfliste.SaisieTextbox:SetParent(lcfliste);
	lcfliste.SaisieTextbox:SetPosition(50,75);
	lcfliste.SaisieTextbox:SetSize(280,20);
	lcfliste.SaisieTextbox:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	lcfliste.SaisieTextbox:SetForeColor(Turbine.UI.Color(0.8, 0.75, 0.5));
	lcfliste.SaisieTextbox:SetBackColor(Turbine.UI.Color(0, 0, 0));
	lcfliste.SaisieTextbox:SetMultiline(false);
	lcfliste.SaisieTextbox.MouseEnter = function()
		info("textbox");
	end
	lcfliste.SaisieTextbox.MouseLeave = function()
		info(0);
	end
	
	lcfliste.SaisieAdd = Turbine.UI.Lotro.Button();
	lcfliste.SaisieAdd:SetParent(lcfliste);
	lcfliste.SaisieAdd:SetPosition(350,75);
	lcfliste.SaisieAdd:SetSize(100,20);
	lcfliste.SaisieAdd:SetText(lang["Ajouter"][L]);
	lcfliste.SaisieAdd:SetForeColor(Turbine.UI.Color(0.8, 0.75, 0.5));
	lcfliste.SaisieAdd.Click = function()
		ajoutMots();
	end

	-- Affichage
	lcfliste.SaisieLabel = Turbine.UI.Label();
	lcfliste.SaisieLabel:SetParent(lcfliste);
	lcfliste.SaisieLabel:SetText(lang["ListeFiltre"][L]);
	lcfliste.SaisieLabel:SetPosition(50,105);
	lcfliste.SaisieLabel:SetSize(300,15);
	lcfliste.SaisieLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	lcfliste.SaisieLabel:SetForeColor(Turbine.UI.Color(0.8, 0.75, 0.5));
	
	lcfliste.SaisieListe:SetParent(lcfliste);
	lcfliste.SaisieListe:SetSize(390,250);
	lcfliste.SaisieListe:SetPosition(50,130);
	lcfliste.SaisieListe:SetBackColor( Turbine.UI.Color(0,0,0));
	lcfliste.SaisieListe:SetVerticalScrollBar(lcfliste.ScrollBar);
	lcfliste.SaisieListe:ClearItems();
	lcfliste.SaisieListe.MouseEnter = function()
		info("listebox");
	end
	lcfliste.SaisieListe.MouseLeave = function()
		info(0);
	end
	
	for i=1,table.getn(listeBan)
	do
		local item = Turbine.UI.Label();
		item:SetSize(390,14);
		item:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
		item:SetForeColor(Turbine.UI.Color(0,1,0));
		item:SetBackColor(Turbine.UI.Color(0, 0, 0));
		item:SetText(listeBan[i]);
		lcfliste.SaisieListe:AddItem(item);
	end
	
	--Suppression de mot
	lcfliste.supp:SetParent(lcfliste);
	lcfliste.supp:SetPosition(350,105);
	lcfliste.supp:SetSize(100,20);
	lcfliste.supp:SetText(lang["Supprimer"][L]);
	lcfliste.supp:SetEnabled(false);
	lcfliste.supp.Click = function()
		lcfliste.SaisieListe:RemoveItem(lcfliste.SaisieListe:GetSelectedItem());
		lcfliste.supp:SetEnabled(false);
	end	
	
	antiSpam();
	
end

function ajoutMots()
	if lcfliste.SaisieTextbox:GetText()~="" then
		local item = Turbine.UI.Label();
		item:SetSize(390,14);
		item:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
		item:SetForeColor(Turbine.UI.Color(1,0,0));
		item:SetBackColor(Turbine.UI.Color(0, 0, 0));
		item:SetText(lcfliste.SaisieTextbox:GetText());
		lcfliste.SaisieListe:AddItem(item);
		lcfliste.SaisieTextbox:SetText("");
	else
		Turbine.Shell.WriteLine(lang["Vide"][L]);
	end
end

-- AntiSpam gestion

function antiSpam()

	lcfliste.AntiSpam:SetParent(lcfliste);
	lcfliste.AntiSpam:SetText(lang["Spam"][L]);
	lcfliste.AntiSpam:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	lcfliste.AntiSpam:SetForeColor(Turbine.UI.Color(0.8, 0.75, 0.5));
	lcfliste.AntiSpam:SetSize(150, 20);
	lcfliste.AntiSpam:SetPosition(50,390);
	lcfliste.AntiSpam:SetCheckAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	lcfliste.AntiSpam.CheckedChanged = function()
		if lcfliste.AntiSpam:IsChecked() then
			lcfliste.SpamLabel:SetVisible(true);
			lcfliste.IntervalleSpam:SetVisible(true);
		else
			lcfliste.SpamLabel:SetVisible(false);
			lcfliste.IntervalleSpam:SetVisible(false);
		end
	end
	lcfliste.AntiSpam.MouseEnter = function()
		info("antispam");
	end
	lcfliste.AntiSpam.MouseLeave = function()
		info(0);
	end
	
	lcfliste.SpamLabel = Turbine.UI.Label();
	lcfliste.SpamLabel:SetParent(lcfliste);
	lcfliste.SpamLabel:SetText(lang["Delais"][L]);
	lcfliste.SpamLabel:SetSize(250,15);
	lcfliste.SpamLabel:SetPosition(190,393);
	lcfliste.SpamLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	lcfliste.SpamLabel:SetForeColor(Turbine.UI.Color(0.8, 0.75, 0.5));
	lcfliste.SpamLabel:SetVisible(lcfliste.AntiSpam:IsChecked());
	lcfliste.SpamLabel.MouseEnter = function()
		info("delais antispam");
	end
	lcfliste.SpamLabel.MouseLeave = function()
		info(0);
	end

	IntervalleSpam=lang["Temps"][L];
	lcfliste.IntervalleSpam = DropDown.Create(IntervalleSpam,valIntervalleSpam);
	lcfliste.IntervalleSpam:SetParent(lcfliste);
	lcfliste.IntervalleSpam:ApplyWidth(80); 
	lcfliste.IntervalleSpam:SetMaxItems(6); 
	lcfliste.IntervalleSpam:SetPosition(360,390);
	lcfliste.IntervalleSpam:SetVisible(lcfliste.AntiSpam:IsChecked());
	
end


function saveMots()
	
	settingsMot={};--para mot
	
	settingsMot.AntiSpam=lcfliste.AntiSpam:IsChecked();
	settingsMot.Intervalle=lcfliste.IntervalleSpam:GetText();
	
	table.remove(listeBan);--Nettoyage
	settingsMot.Nombre=tostring(lcfliste.SaisieListe:GetItemCount());
	
	for i=1,lcfliste.SaisieListe:GetItemCount()
	do
		temp=lcfliste.SaisieListe:GetItem(i);
		settingsMot[tostring(i)]=temp:GetText();
		listeBan[i]=temp:GetText();
	end
	
	Turbine.PluginData.Save(Turbine.DataScope.Character, "lcfMot", settingsMot);--save mot ban
	
	Delais();
	
end

function chargeMots()
	settingsMot=Turbine.PluginData.Load(Turbine.DataScope.Character, "lcfMot");
	if settingsMot==nil then
		settingsMot={};
	else
	
		lcfliste.AntiSpam:SetChecked(settingsMot.AntiSpam);
		AntiSpamActive=settingsMot.AntiSpam;
		valIntervalleSpam=settingsMot.Intervalle;
	
		for i=1,settingsMot.Nombre
		do
			listeBan[i]=settingsMot[tostring(i)];
		end
	end
	Delais();
end

-- Selection

lcfliste.SaisieListe.SelectedIndexChanged = function()
	for i=1,lcfliste.SaisieListe:GetItemCount()
	do
		temp1=lcfliste.SaisieListe:GetItem(i);
		temp1:SetBackColor(Turbine.UI.Color(0, 0, 0));
	end
		temp2=lcfliste.SaisieListe:GetSelectedItem();
		temp2:SetBackColor(Turbine.UI.Color(0, 0, 1));
		lcfliste.supp:SetEnabled(true);
end